<div class="language-mapper" id="{{ widget.attrs.id }}__wrapper">
  <input type="hidden" name="{{ widget.name }}" value="{{ value_json }}" />
  <div class="language-mapper--select">
    <select name="{{ widget.name }}__choices"
            required
            id="{{ widget.attrs.id }}"
            multiple>
      {% for code, name, is_selected in available_languages %}
        <option value="{{ code }}" {% if is_selected %}selected{% endif %}
          {# the display: inline  comment prevents prettier from messing up the whitespace around {{ name }} #}
          >{{ name }}
        </option>
      {% endfor %}
    </select>
  </div>
  <div class="language-mapper--levels"></div>
</div>
<template id="language-mapper--template">
  <div class="language-mapper-level">
    <label class="language required"></label>
    <select required>
      <option disabled selected value="">--</option>
      <option value="0">Basic (A1-A2)</option>
      <option value="1">Good (B1-B2)</option>
      <option value="2">Fluent (C1-C2)</option>
      <option value="3">Native Speaker</option>
    </select>
  </div>
</template>
<script>
  window.addEventListener("load", (event) => {
    const wrapper = document.getElementById("{{ widget.attrs.id }}__wrapper");
    const languageNames = Object.fromEntries(
      Array.from(wrapper.querySelectorAll("option")).map((option) => [
        option.value,
        option.label,
      ])
    );

    const select = document.getElementById("{{ widget.attrs.id}}");
    const hiddenInput = wrapper.querySelector('input[name="{{ widget.name }}"]');
    let value = JSON.parse(hiddenInput.value);
    const slidersContainer = wrapper.querySelector(".language-mapper--levels");
    const sliderTemplate = document.getElementById("language-mapper--template");

    function writeValueToHiddenInput() {
      hiddenInput.value = JSON.stringify(value);
    }

    function addLanguage(language, points) {
      const newSlider = sliderTemplate.content.cloneNode(true);
      newSlider.querySelector("div").dataset.language = language;
      const label = newSlider.querySelector("label");
      const select = newSlider.querySelector("select");
      const id = `language-mapper--slider--${language}`;

      select.id = id;
      label.setAttribute("for", id);
      label.textContent = languageNames[language];
      if (points !== null) {
        select.value = points;
      }
      select.addEventListener("change", (event) => {
        value[language] = parseInt(select.value);
        writeValueToHiddenInput();
      });

      slidersContainer.appendChild(newSlider);
    }

    function removeLanguage(language) {
      delete value[language];
      writeValueToHiddenInput();

      slidersContainer.querySelector(`[data-language="${language}"]`).remove();
    }

    Object.entries(value).forEach(([language, points]) =>
      addLanguage(language, points)
    );

    const label = select.labels[0];
    if (!label.id) {
      // Generate an id real quick
      var arr = new Uint8Array(20);
      window.crypto.getRandomValues(arr);
      label.id = Array.from(arr, (d) => d.toString(16).padStart(2, "0")).join("");
    }

    select._choices = new Choices(select, {
      removeItemButton: true,
      duplicateItemsAllowed: false,
      allowHTML: false,
      labelId: label.id,
    });

    if (select.required) {
      // This is replicated in planner_common/forms/widgets/_choicesjs_script.html
      // Not ideal, but I don't know how to properly DRY it right now
      const e = select._choices.containerOuter.element;
      e.classList.add('invalid')
      select.addEventListener('change', () => {
        if (select.selectedOptions.length == 0) {
          e.classList.remove('valid')
          e.classList.add('invalid')
        } else {
          e.classList.remove('invalid')
          e.classList.add('valid')
        }
      })
    }

    // Work around weird issue where the choicesList is tabbable to. Doesn't happen with the
    // reference page, so it has to be caused by us, but I cannot figure out what we did.
    select._choices.choiceList.element.tabIndex = -1;

    select.addEventListener("addItem", (event) =>
      addLanguage(event.detail.value, null)
    );
    select.addEventListener("removeItem", (event) =>
      removeLanguage(event.detail.value)
    );
  });
</script>
